<template>
	<f7-page name="accountstore" @page:beforein="onPageBeforeIn" @page:beforeout="onPageBeforeOut">
		<!-- Top Navbar -->
		<f7-navbar :sliding="false" large>
			<f7-nav-left back-link>
            </f7-nav-left>
            <f7-nav-title class="show-small-title">Akun</f7-nav-title>
            <f7-nav-title-large>Toko/Warung</f7-nav-title-large>
		</f7-navbar>
        <f7-block style="text-align: justify;padding:20px;border-radius:7px;" class="no-margin gradient-cyan">
            <h3 class="no-margin">Penting!</h3>
            <p>Untuk bisa berjualan anda wajib mengisikan informasi toko/warung anda.</p>
        </f7-block>
        <f7-list no-hairlines>
            <f7-list-input
                ref="store_name"
                label="Nama Toko"
                type="text"
                placeholder="Ketik nama toko"
                clear-button
                :value="storeForm.name"
                @input="storeForm.name = $event.target.value"
            ></f7-list-input>
            <f7-list-input
                ref="store_about"
                label="Deskripsi Toko"
                type="textarea"
                placeholder="Ketik deskripsi toko"
                resizable
                :value="storeForm.about"
                @input="storeForm.about = $event.target.value"
            ></f7-list-input>
            <f7-list-input
                ref="open"
                name="open"
                label="Jam Buka"
                type="text"
                readonly
                :value="storeForm.open"
            ></f7-list-input>
            <f7-list-input
                ref="close"
                name="close"
                label="Jam Tutup"
                type="text"
                readonly
                :value="storeForm.close"
            ></f7-list-input>
            <li>
                <div class="item-content item-input item-input-with-value">
                    <div class="item-inner no-padding-right">
                        <div class="item-title item-label">Lokasi Toko/Warung</div>
                        <div class="item-input-wrap">
                            <GmapMap 
                                id="map"
                                class="margin-small-top"
                                ref="mapRef"
                                :options="{
                                    zoomControl: true,
                                    mapTypeControl: false,
                                    scaleControl: false,
                                    streetViewControl: false,
                                    rotateControl: false,
                                    fullscreenControl: true,
                                    disableDefaultUi: false,
                                    scrollwheel: false
                                }"
                                :zoom="map.zoom"
                                :center="map.center"
                                :draggable="true"
                                @center_changed="handleCenterChanged($event)">
                            </GmapMap>
                        </div>
                    </div>
                </div>				
			</li>
        </f7-list>
        <f7-button @click="doSubmit" fill-ios round-ios color="white" icon-f7="arrow_right" class="gradient-button-blue text-align-left width-100" large>Simpan</f7-button>
    </f7-page>
</template>
<script>
import moment from 'moment';
import { mapGetters } from 'vuex';
import { gmapApi } from 'vue2-google-maps';
import { dateFormat, capitalize, parseError } from '../js/utils';
export default {
    name: 'AccountStore',
    data(){
        return{
            map: {
				zoom: 14,
				center: {
					lat: -2.9760735,
					lng: 104.77543070000002
				}
			},
            storeForm: {
                name: '',
                about: '',
                open: '00:00',
                close: '00:00',
                latitude: null,
                longitude: null
            }
        };
    },
    computed: {
        ...mapGetters('auth', ['user']),
        currentLocation: function(){
			const self = this;

			let currentLocation = localStorage.getItem('currentLocation') ? JSON.parse(localStorage.getItem('currentLocation')) : null;
			return currentLocation;
		}
    },
    methods: {
        dateFormat,
        google: gmapApi,
        onPageBeforeIn(){

            const self = this;
            const app = self.$f7;

            self.storeForm.name = self.user.profile.store_name != null ? self.user.profile.store_name : '';
            self.storeForm.about = self.user.profile.store_about != null ? self.user.profile.store_about : '';

            if(self.user.profile.store_open != null){
                self.storeForm.open = self.user.profile.store_open;
            }

            if(self.user.profile.store_close != null){
                self.storeForm.close = self.user.profile.store_close;
            }

            if(self.user.profile.latitude != null && self.user.profile.longitude != null){
                self.map.zoom = 20;
                self.map.center.lat = self.user.profile.latitude;
                self.map.center.lng = self.user.profile.longitude;
            }else if(currentLocation != null){
                self.map.zoom = 20;
                self.map.center.lat = self.currentLocation.latitude;
                self.map.center.lng = self.currentLocation.longitude;
            }
        },
        onPageBeforeOut(page){
            const self = this;
			const app = self.$f7;

			if(page.detail.name != 'account'){
				self.storeForm = {
					id: null,
                    name: '',
                    about: '',
                    latitude: null,
                    longitude: null
                }
                
                self.map = {
                    zoom: 14,
                    center: {
                        lat: -2.9760735,
                        lng: 104.77543070000002
                    }
                };
			}			
        },
        doSubmit(){
            const self = this;
            const app = self.$f7;
            const $$ = self.$$;

            let open = $$('input[name="open"]').val();
            let close = $$('input[name="close"]').val();

            if(self.storeForm.name.trim().length === 0){
                app.dialog.alert('Nama toko wajib diisi', 'RingSatu');
                return false;
            }else if(self.storeForm.name.trim().length > 255){
                app.dialog.alert('Nama toko maksimum 255 karakter', 'RingSatu');
                return false;
            }else if(self.storeForm.about.trim().length === 0){
                app.dialog.alert('Nama toko wajib diisi', 'RingSatu');
                return false;
            }else if(self.storeForm.about.trim().length > 255){
                app.dialog.alert('Deskripsi toko maksimum 255', 'RingSatu');
                return false;
            }

            app.preloader.show('green');

            self.$store.dispatch('auth/updateStore', {
                store_name: self.storeForm.name,
                store_about: self.storeForm.about,
                store_open: open,
                store_close: close,
                latitude: self.storeForm.latitude,
                longitude: self.storeForm.longitude
            }).then((response) => {
                app.preloader.hide();

				if('errors' in response){
					let error = parseError(response.errors);
					app.dialog.alert(error.messages, 'RingSatu');
					return false;
				}else{
					self.$f7router.back({
						ignoreCache: true
					});
				}
            });
        },
        setCenterMarker(){
			const self = this;
			const $$ = self.$$;

			setTimeout(() => {
				self.$refs.mapRef.$mapPromise.then((map) => {
					$$('<div/>').addClass('centerMarker').appendTo(map.getDiv());
				});
			}, 100);
		},
		handleCenterChanged(e){
			const self = this;
			setTimeout(() => {
				self.storeForm.latitude = e.lat();
				self.storeForm.longitude = e.lng();
			}, 3000);
		},
    },
    mounted(){
        const self = this;
        const app = self.$f7;
        const $$ = self.$$;
        const $el = $$(self.$el);
        
        self.setCenterMarker();

        let openingHour = app.picker.create({
            inputEl: 'input[name="open"]',
            rotateEffect: true,
            cols: [{
                values: (function () {
                    var arr = [];
                    for (var i = 0; i <= 23; i++) { arr.push(i < 10 ? '0' + i : i); }
                    return arr;
                })(),
            }, {
                divider: true,
                content: ':'
            }, {
                values: (function () {
                    var arr = [];
                    for (var i = 0; i <= 59; i++) { arr.push(i < 10 ? '0' + i : i); }
                    return arr;
                })(),
            }],
            on: {
                open: function(picker){
                    picker.setValue(self.storeForm.open.split(":"));
                },
                change: function (picker, values, displayValues) {
                    setTimeout(()=>{
                        $$('input[name="open"]').val(displayValues.join(":"));
                    },100);
                }
            }
        });

        let closingHour = app.picker.create({
            inputEl: 'input[name="close"]',
            rotateEffect: true,
            cols: [{
                values: (function () {
                    var arr = [];
                    for (var i = 0; i <= 23; i++) { arr.push(i < 10 ? '0' + i : i); }
                    return arr;
                })(),
            }, {
                divider: true,
                content: ':'
            }, {
                values: (function () {
                    var arr = [];
                    for (var i = 0; i <= 59; i++) { arr.push(i < 10 ? '0' + i : i); }
                    return arr;
                })(),
            }],
            on: {
                open: function(picker){
                    picker.setValue(self.storeForm.close.split(":"));
                },
                change: function (picker, values, displayValues) {
                    setTimeout(()=>{
                        $$('input[name="close"]').val(displayValues.join(":"));
                    },100);
                }
            }
        });
    }
}
</script>
